#include "stdafx.h"
#include "seznam.h"

void listShow(listDescr *list)
{
  item *temp;
  int n=0;
  temp=list->first;
  if (temp == NULL)
    puts("List Empty");
  else
  {
    for(temp = list->first; temp; temp = temp->next)
    {
      n++;
      printf("%3d  ", n);
      printf("%s %s %s %s %s %s %s\n", 
        temp->first_name, temp->last_name,
        temp->company_name, temp->address, 
        temp->city, temp->county, temp->state);
    }
  }
}

bool listClear(listDescr *list)
{
  if (list->first == NULL)
    return false;

  while(list->first)
  {
    item *temp = list->first->next;
    freeItem(list->first);
    list->first = temp;
  }
  return true;
}

bool listAdd(listDescr *list, char *txt)
{
  item *temp, *newItem;
  newItem=createItemFromLime(txt);
  if (newItem==NULL) return false;   

    // pridava se na konec
  if (list->first == NULL)
    list->first = newItem;
  else
  {
    for(temp = list->first; temp->next; temp = temp->next)
      ;   // hledat posledni

    temp->next = newItem;   // za nej ten novy
  }
  return true;
}

char *allocVal(char *src)
{
  char *cp = (char *)malloc(strlen(src) + 1);
  if (cp)
    strcpy(cp, src);

  return cp;
}


bool freeItem(item *x)
{
  if (!x)
    return false;

  int column;
  for(column = 0; column < WORKING_COLUMNS; column++)
  {
    char *cp=((ppchar)x)[column];
    if (cp != NULL)
      free(cp);
  }

  free(x);
  return true;
}

item *createItemFromLime(char *txt)
{
   int i;
   char bf[300];
   char *cp;
   strcpy(bf, txt);
   item *temp;
   
   temp=(item *)malloc(sizeof(item));
   if (temp==NULL) return temp;
   memset(temp, 0, sizeof(item));
   cp=strtok(bf, TOKEN_DELIMS);
   for (i=0;i<WORKING_COLUMNS;i++)
   {
		((ppchar)temp)[i]=allocVal(cp);
        cp=strtok(NULL, TOKEN_DELIMS);
   }
   return temp;
}

